import express from 'express';
import path from 'path';
import { removeLeadingDot } from './utils';

export function getStaticPath(relPath: string) {
  return path.join(__dirname, 'static', relPath);
}

export function serveStaticDir(
  app: express.Application,
  staticPath: string,
  publicUrl: string
) {
  const relStaticPath = path.relative(process.cwd(), staticPath);
  console.log(`[Cosmos] Serving static files from ${relStaticPath}`);

  app.use(
    removeLeadingDot(publicUrl),
    express.static(staticPath, {
      // Ensure loader index (generated by html-webpack-plugin) loads instead
      // of the index.html from staticPath
      index: false,
    })
  );
}
